
#include <Wire.h>
#include <L3G.h>
#include <LSM303.h>

LSM303 compass;
L3G gyro;

String sample;
unsigned long counter;

void setup() {
  Serial.begin(9600);
  Wire.begin();
  
  if (!gyro.init())
  {
    Serial.println("Failed to autodetect gyro type!");
    while (1);
  }

  gyro.enableDefault();
  compass.init();
  compass.enableDefault();

  //set gyro range to 2000dps
  gyro.writeReg(L3G_CTRL_REG4, 0x20);

  //set acc sensor range to +-8g
  compass.writeAccReg(LSM303_CTRL_REG4_A, 0x30);
  
  //set mag rate 220Hz
  compass.writeMagReg(LSM303_CRA_REG_M, 0x1C);

  Serial.print("Gyro mode (L3G_CTRL_REG1): ");
  Serial.println(gyro.readReg(L3G_CTRL_REG1));
  Serial.print("Gyro Scaling status (L3G_CTRL_REG4): ");
  Serial.println(gyro.readReg(L3G_CTRL_REG4));

  Serial.print("Acc mode (LSM303_CTRL_REG1_A): ");
  Serial.println(compass.readAccReg(LSM303_CTRL_REG1_A));
  Serial.print("Acc Scaling status (LSM303_CTRL_REG4_A): ");
  Serial.println(compass.readAccReg(LSM303_CTRL_REG4_A));

  Serial.print("Mag mode (LSM303_MR_REG_M): ");
  Serial.println(compass.readMagReg(LSM303_MR_REG_M));
  Serial.print("Mag Scaling status(A) (LSM303_CRA_REG_M): ");
  Serial.println(compass.readMagReg(LSM303_CRA_REG_M));
  Serial.print("Mag Scaling status(B) (LSM303_CRB_REG_M): ");
  Serial.println(compass.readMagReg(LSM303_CRB_REG_M));

  sample = String("");
  counter = 0;
 }

void loop() {
  gyro.read();
  compass.read();
  counter = counter+1;

  sample = "";	
  sample +=(int)gyro.g.x;
  sample += " ";
  sample +=(int)gyro.g.y;
  sample += " ";
  sample +=(int)gyro.g.z;
  sample += " ";

  sample +=(int)compass.a.x;
  sample += " ";
  sample +=(int)compass.a.y;
  sample += " ";
  sample +=(int)compass.a.z;
  sample += " ";

  sample +=(int)compass.m.x;
  sample += " ";
  sample +=(int)compass.m.y;
  sample += " ";
  sample +=(int)compass.m.z;

  sample += " ";
  sample += counter;
  
  Serial.println(sample);
  
  delay(10);
}

